// ZenLib::File - standart files functions
// Copyright (C) 2002-2003 Jrme Martinez, Zen@MediaArea.net
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// File
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Version 0.0.1
// -------------
// Fonctions de base des entres sorties de fichiers
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// 1.0.0 (Zen@MediaArea.net)
// Bases
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---------------------------------------------------------------------------
#ifndef ZenFileH
#define ZenFileH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <ZenLib/Conf.h>
#include <ZenLib/ZtringList.h>
//---------------------------------------------------------------------------

namespace ZenLib
{

//***************************************************************************
// Classe CFichier_Texte
//***************************************************************************

class File_
{
public :
    //Gestion de la classe
    File_ ();
    ~File_ ();

    //Ouverture/fermeture
    virtual int Ouvrir (const Ztring &Fichier, bool Nouveau=false, bool Ajout=false, bool Ecriture=false)=0;
    virtual void Fermer ()=0;

    //Divers
    virtual bool Eof(); //Fin de fichier
    int Supprimer(); //Supprimer le fichier en cours
    Ztring Nom_Get();
    uint64 Size_Get();
    static uint64 Size_Get(const Ztring &Fichier);

    //Utils
    static int Supprimer(Ztring &Fichier); //Supprimer le fichier cite
    static ZtringList Chercher(Ztring Liste); //Rechercher la liste de fichier
    static int Exist(Ztring File); //Le fichier existe?
    static int Copy(Ztring &Existing, Ztring &New, int FailExist=0); //FailExist=false --> Overwrite

protected :
    bool End; //Indicateur de fin de fichier
    Ztring Nom; //Nom du fichier en cours
};

} //Namespace

#endif
