// ZenLib::ZtringListListF - ZtringListList with files
// Copyright (C) 2002-2003 Jrme Martinez, Zen@MediaArea.net
//
// This software is provided 'as-is', without any express or implied
// warranty.  In no event will the authors be held liable for any damages
// arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 3. This notice may not be removed or altered from any source distribution.
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ZtringListList
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// Version 1.0.0
// -------------
// Gestion d'un tableau de CChaine avec option de chargement/sauvegarde
// Sauvegarde au format CSV ou CFG
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
// 1.0.0
// Nettoyages
//
// 0.0.4
// Possibilite de desactiver la sauvegarde
// Definition du nombre de backup maxi
//
// 0.0.3
// Gestion de 10 backups maxi
// 
// 0.0.2
// Chargement/Sauvegarde CFG
// 
// 0.0.1
// Chargement/Sauvegarde CSV
// 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//---------------------------------------------------------------------------
#ifndef ZtringListListFH
#define ZtringListListFH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <ZenLib/ZtringListList.h>
//---------------------------------------------------------------------------

namespace ZenLib
{


//***************************************************************************
// Classe CChaine_Tableau2F
//***************************************************************************

class ZtringListListF : public ZtringListList
{
public :
    //Gestion de la classe
    ZtringListListF (int Taille2=1, int TailleBase1=1, const Ztring &Separateur1="\r\n", const Ztring &Separateur2=";", const char *Source="");
    ~ZtringListListF ();

    //Gestion disque
    int Charger (const Ztring &Fichier="");
    int Sauvegarder (const Ztring &Fichier="");
    int Annuler ();

    //Divers
    int Sauvegarde_Set(bool Sauvegarde); // activer ou desactiver la sauvegarde sur disque
    int Backup_Set (int Nombre); //Nombre de backup

protected :
    Ztring Nom; //Nom du fichier
    bool Sauvegarde; //Indicateur si on a le droit de sauvegarder (par defaut)
    int Backup_Nb_Max; //Nombre maxi de sauvegardes
    int Backup_Nb; //Nombre actuel de backups pour cette session

    //Chargement
    int CSV_Charger ();
    int CFG_Charger ();

    //Sauvegarde
    int CSV_Sauvegarder ();
    int CFG_Sauvegarder ();

    //Divers
    int NettoyerEspaces (Ztring &ANettoyer); //Enlever les espaces avant et apres
};

} //Namespace

#endif

